#include <stdio.h>
#include <glib.h>
#include <GL/gl.h>

#include <g3dviewer_plugin.h>

gint32 g3d_read_int8(FILE *f)
{
  int c = fgetc(f);
  if(c == EOF) return 0;
  else return c;
}

gint32 g3d_read_int16_be(FILE *f)
{
  return (g3d_read_int8(f)<<8) | g3d_read_int8(f);
}

gint32 g3d_read_int16_le(FILE *f)
{
  return g3d_read_int8(f) | (g3d_read_int8(f)<<8);
}

gint32 g3d_read_int32_be(FILE *f)
{
  return (g3d_read_int8(f) << 24) | (g3d_read_int8(f) << 16) | 
         (g3d_read_int8(f) <<  8) |  g3d_read_int8(f);
}

gint32 g3d_read_int32_le(FILE *f)
{
  return  g3d_read_int8(f)        | (g3d_read_int8(f) << 8) |
         (g3d_read_int8(f) << 16) | (g3d_read_int8(f) << 24);
}

GLfloat g3d_read_float_be(FILE *f)
{
  gint32 x = g3d_read_int32_be(f);
  return *(GLfloat*)&x;
}

GLfloat g3d_read_float_le(FILE *f)
{
  gint32 x = g3d_read_int32_le(f);
  return *(GLfloat*)&x;
}

void g3d_read_dumphex(FILE *f, int nbytes)
{
  int toread = nbytes;
  int max, col = 0;
  int row[16];
  unsigned long int address = ftell(f);

  printf("%8.8lX:  ", address);
  while(toread != 0)
  {
    row[col] = fgetc(f);
    if(row[col] == -1) return;
    printf("%.2X ", row[col]);
    col++;
    if(col == 16)
    {
      printf("  | ");
      for(col=0; col<16; col++)
      {
        if((row[col] >=32) && (row[col] <127)) putchar(row[col]);
        else putchar('.');
      }
      printf("\n");
      address += 16;
      printf("%8.8lX:  ", address);
      col=0;
    }
    toread--;
  }
  max = col;
  while(col < 16) { printf("   "); col++; }
  printf("  | ");
  for(col=0; col<max; col++)
  {
    if((row[col] >=32) && (row[col] <127)) putchar(row[col]);
    else putchar('.');
  }
  printf("\n");
}

